> For the complete documentation index, see [llms.txt](https://docs.finpay.id/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.finpay.id/api-reference/finpay-money/linkage/customer-top-up/customer-top-up.md).

# Customer Top Up

This API will be used to cash-in the amount value into customer e-money account balance, crediting the account balance.

### Technical Specification <a href="#technical-specification" id="technical-specification"></a>

```
Service Code: 38
```

| Environment | Method | URL                                               |
| ----------- | ------ | ------------------------------------------------- |
| Development | POST   | <https://snapstag.finnet.co.id/v1.0/emoney/topup> |
| Production  | POST   | <https://snap.finnet.co.id/v1.0/emoney/topup>     |

### Body Request <a href="#body-request" id="body-request"></a>

<table><thead><tr><th>No</th><th>Name</th><th>Type</th><th>Mandatory</th><th width="128">Min Length</th><th>Max Length</th><th>Description</th></tr></thead><tbody><tr><td>1</td><td>partnerReferenceNo</td><td>String</td><td>M</td><td>1</td><td>64</td><td>Transaction identifier on service consumer system</td></tr><tr><td>2</td><td>customerNumber</td><td>String</td><td>M</td><td>1</td><td>16</td><td>Customer phone number with 08xx format</td></tr><tr><td>3</td><td>customerName</td><td>String</td><td>M</td><td>1</td><td>255</td><td>Customer name from inquiry response</td></tr><tr><td>4</td><td>amount</td><td><a href="/pages/a6X3BtoHD9KBCKz6uELV">Object</a></td><td>M</td><td>1</td><td>2</td><td>Transaction Amount</td></tr><tr><td>5</td><td>feeAmount</td><td><a href="/pages/ZgPkEq3nU5zSTZNABeDn">Object</a></td><td>M</td><td>1</td><td>2</td><td>Fee amount object from inquiry response</td></tr><tr><td>6</td><td>transactionDate</td><td>String</td><td>M</td><td>1</td><td>25</td><td>YYYY-MM-DDThh:mm:ssZ format</td></tr></tbody></table>

#### Sample Request <a href="#sample-request" id="sample-request"></a>

```
{
  "partnerReferenceNo": "78912343452347893",
  "customerNumber": "081977817902",
  "customerName": "sa**",
  "amount": {
    "value": "10000.00",
    "currency": "IDR"
  },
  "feeAmount": {
    "value": "0.00",
    "currency": "IDR"
  },
  "transactionDate": "2022-09-23T14:56:11+07:00"
}
```

### Body Response <a href="#body-response" id="body-response"></a>

| No | Name               | Type                                                              | Mandatory | Min Length | Max Length | Description                                       |
| -- | ------------------ | ----------------------------------------------------------------- | --------- | ---------- | ---------- | ------------------------------------------------- |
| 1  | responseCode       | [Enum](/api-reference/appendix/enumeration/response-code-list.md) | M         | 1          | 7          | BI SNAP Response Code.                            |
| 2  | responseMessage    | String                                                            | M         | 1          | 150        | BI SNAP Response Message.                         |
| 3  | referenceNo        | String                                                            | O         | 1          | 64         | Transaction identifier on service provider system |
| 4  | partnerReferenceNo | String                                                            | O         | 1          | 64         | Transaction identifier on service consumer system |
| 5  | customerNumber     | String                                                            | O         | 1          | 64         | Masked customer phone number with 08xx format     |
| 6  | customerName       | String                                                            | M         | 1          | 255        | Masked customer account name                      |
| 7  | amount             | [Object](/api-reference/appendix/json-object/amount-object.md)    | O         | 1          | 2          | Detail of amount transaction                      |

#### Sample Response <a href="#sample-response" id="sample-response"></a>

```
{
  "responseCode": "2003800",
  "responseMessage": "Request has been processed successfully",
  "referenceNo": "2211150005490937",
  "partnerReferenceNo": "78912343452347893",
  "customerNumber": "081977817902",
  "amount": {
    "value": "10000.00",
    "currency": "IDR"
  }
}
```

### Response Code & Message <a href="#response-code--message" id="response-code--message"></a>

The table below lists response codes and messages for the Customer Top Up API.

| No | HTTP Code | Code    | Message (Indonesian)                   |
| -- | --------- | ------- | -------------------------------------- |
| 1  | 200       | 2003800 | Successful                             |
| 2  | 200       | 2003900 | Request has been processed succesfully |
| 3  | 400       | 4003800 | Bad request                            |
| 4  | 400       | 4003801 | Invalid field format {field}           |
| 5  | 400       | 4003802 | Invalid mandatory field {field}        |
| 6  | 401       | 4013801 | Invalid token (B2B)                    |
| 7  | 401       | 4013800 | Unauthorised. \[Reason]                |
| 8  | 403       | 4033801 | Feature not allowed                    |
| 9  | 403       | 4033804 | Activity count limit exceeded          |
| 10 | 404       | 4043808 | Invalid merchant                       |
| 11 | 500       | 5003800 | General error                          |
| 12 | 504       | 5043800 | Timeout                                |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.finpay.id/api-reference/finpay-money/linkage/customer-top-up/customer-top-up.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
